import numpy as np
from sklearn.model_selection import train_test_split
from sklearn.linear_model import LinearRegression

# Leemos los datos de entrada
X = np.loadtxt( "datos.txt" )
print( X.shape )

# Separamos los datos para entrenamiento y prueba
X_entrena, X_prueba, y_entrena, y_prueba = train_test_split( X[:,0], X[:,1], random_state=2 )

# Lo forzamos a que sean vectores columna
X_entrena = X_entrena.reshape( (-1,1) )
print( X_entrena.shape )
X_prueba = X_prueba.reshape( (-1,1) )
print( X_prueba.shape )

n, m = X_entrena.shape
# Vamos a construir nuestra matriz para el ajuste de una parábola
D = np.zeros( (n,2) )
D[:,0] = X_entrena[:,0]*X_entrena[:,0]
D[:,1] = X_entrena[:,0]


n, m = X_prueba.shape
D_prueba = np.zeros( (n,2) )
D_prueba[:,0] = X_prueba[:,0]*X_prueba[:,0]
D_prueba[:,1] = X_prueba[:,0]

# Realizamos al ajuste
reg = LinearRegression()
reg.fit( D, y_entrena)

y_predichas = reg.predict(D_prueba)

v = y_prueba - y_predichas
v = v.reshape( (-1,1) )
print( v.shape )
n, m = v.shape

error_rms = np.sqrt( ( v.T @ v )/n ) 
#                     1xn  nx1 

print( "Error RMS =", error_rms )

print( "El modelo:" )
print( reg.coef_  )
print( reg.intercept_ )

